#line 1 "F:/MikroC/KnigntRider/knightRider.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "f:/mikroc/knigntrider/anim.h"
#line 1 "f:/mikroc/knigntrider/fader.h"
#line 1 "f:/mikroc/knigntrider/types.h"
#line 14 "f:/mikroc/knigntrider/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 18 "f:/mikroc/knigntrider/fader.h"
 typedef struct {

 uint aryuintStates[2];
 uint uintRepeat;
 } scheduleDef;

 typedef struct faderNode {
 unsigned uBounce : 1;
 unsigned uDirection : 1;
 unsigned uLoop : 1;
 unsigned uPin : 3;
 unsigned uState : 1;
 unsigned uStop : 1;
 volatile ushort* pPort;
 uint uintSteps;
 int intStep;
 int intLastStep;
 uint uintCtr;
 uint uintRepeat;

 void (*pCB)();

 scheduleDef* pSchItem;

 struct faderNode* pNext;
 } faderDef;


 boolean createFader(faderDef* pFader, byte* pPort, byte uPin,
 uint uintSteps, boolean blnDir, boolean blnBounce,
 boolean blnLoop, boolean blnState, boolean blnStopped,
 void (*pCB)());
 int createSchedule(uint uintInc, uint uintRepeat);
 void serviceFaders();
#line 19 "f:/mikroc/knigntrider/anim.h"
 typedef struct {
 byte bPin;
 uint* puintPreDelay;
 uint* puintPostDelay;
 faderDef fader;
 } outputScheduleDef;

 typedef struct _animDef {
 volatile ushort* pPort;
 byte bTotalSteps;
 union {
 char bits;
 struct {
 unsigned uLoop : 1;
 unsigned uBounce : 1;
 unsigned uDir : 1;
 unsigned uStop : 1;
 };
 } flags;
 outputScheduleDef* parySeq;
 int intIndex;
 byte bStage;
 uint uintCtr;
 struct _animDef* pCurrent;
 struct _animDef* pHead;
 struct _animDef* pTail;
 struct _animDef* pPrev;
 struct _animDef* pNext;
 } animDef;


 void initAnim(animDef* pAnim, int intSteps);
 void joinAnims(animDef* pDst, animDef* pSrc);
 void playAnimation(animDef* pAnim);
#line 1 "f:/mikroc/knigntrider/7segled.h"
#line 1 "f:/mikroc/knigntrider/fader.h"
#line 56 "f:/mikroc/knigntrider/7segled.h"
 void update7SegLEDs(unsigned long ulngCtr, unsigned long ulngFreq);
#line 1 "f:/mikroc/knigntrider/lcd.h"
#line 1 "f:/mikroc/knigntrider/types.h"
#line 23 "f:/mikroc/knigntrider/lcd.h"
 typedef struct {
 int intRow;
 char* pstrMarquee;
 int intStartIdx;
 } marqueeDef;

 void initLCD();
 void lcdMaquee(marqueeDef* pMarquee);
 void lcdText(int intOptions, char* pText);
#line 31 "F:/MikroC/KnigntRider/knightRider.c"
static volatile uint uintPostDelay =  ( ((uint)5000)  / 25) ;

static volatile outputScheduleDef aryLEDseqC[] = {
 { 0 }, { 1 }, { 2 }, { 3 }, { 4 }, { 5 }, { 6 }, { 7 } };
static volatile outputScheduleDef aryLEDseqD[] = {
 { 0 }, { 1 }, { 2 }, { 3 }, { 4 }, { 5 }, { 6 }, { 7 } };
static volatile animDef animC =
 { &LATC,  (sizeof(aryLEDseqC) / sizeof(aryLEDseqC[0])) , 3, aryLEDseqC };
static volatile animDef animD =
 { &LATD,  (sizeof(aryLEDseqD) / sizeof(aryLEDseqD[0])) , 3, aryLEDseqD };
#line 44 "F:/MikroC/KnigntRider/knightRider.c"
void interrupt() {
 playAnimation(&animC);

 TMR0H = 0xFF;
 TMR0L = 0xCE;
 TMR0IF_bit = 0;
}
#line 54 "F:/MikroC/KnigntRider/knightRider.c"
void main() {
 int intSteps;


 ANSELA = 0x02;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
#line 66 "F:/MikroC/KnigntRider/knightRider.c"
 TRISA = 0x02;
 TRISB = 0;
 TRISC = 0;
 TRISD = 0;
 LATB = 0;
 LATC = 0;
 LATD = 0;

 initLCD();

 lcdText( 0x10  |  0x40 , "Knight Rider");
 lcdText( 0x20  |  0x40 , "v2 07/07/2012");

 for( intSteps=0; intSteps< (sizeof(aryLEDseqC) / sizeof(aryLEDseqC[0])) ; intSteps++ ) {
 aryLEDseqC[intSteps].puintPostDelay = &uintPostDelay;
 }
 for( intSteps=0; intSteps< (sizeof(aryLEDseqD) / sizeof(aryLEDseqD[0])) ; intSteps++ ) {
 aryLEDseqD[intSteps].puintPostDelay = &uintPostDelay;
 }



 intSteps = createSchedule(5, 0);

 initAnim(&animC, intSteps);
 initAnim(&animD, intSteps);

 joinAnims(&animC, &animD);



 T0CON.TMR0ON = 1;
 T0CON.T08BIT = 0;
 T0CON.T0CS = 0;
 T0CON.T0SE = 0;
 T0CON.PSA = 0;
 T0CON.T0PS2 = 1;
 T0CON.T0PS1 = 0;
 T0CON.T0PS0 = 0;
 TMR0H = 0xFF;
 TMR0L = 0xCE;
 TMR0IE_bit = 1;

 GIE_bit = 1;

 while (1) {

 uintPostDelay = min(900, max(1, ADC_Read(1)));
 }
}
