/**
 * File:
 *  lcd.h
 *
 * Notes:
 *  This file contains the prototype for LCD routines.
 *
 * History:
 *  02/06/2012 Created by Simon Platten
 */
#ifndef LCD_H
  #define LCD_H
  
  #include "types.h"
// Constants
  #define LCD_CHAR_WIDTH        16
  #define LCD_CHAR_HEIGHT       2
// options
  #define LCD_ROW_1             0x10
  #define LCD_ROW_2             0x20
  #define LCD_CENTER            0x40
// types
  typedef struct {
    int   intRow;
    char* pstrMarquee;
    int   intStartIdx;
  } marqueeDef;
// Prototypes
  void initLCD();
  void lcdMaquee(marqueeDef* pMarquee);
  void lcdText(int intOptions, char* pText);
#endif